import { type Container, type Particle, ParticlesInteractorBase, type RecursivePartial } from "tsparticles-engine";
import type { IRepulseParticlesOptions, RepulseParticlesOptions } from "./Types";
type RepulseParticle = Particle & {
    options: RepulseParticlesOptions;
    repulse?: {
        distance: number;
        factor: number;
        speed: number;
    };
};
export declare class Repulser extends ParticlesInteractorBase {
    constructor(container: Container);
    clear(): void;
    init(): void;
    interact(p1: RepulseParticle): Promise<void>;
    isEnabled(particle: RepulseParticle): boolean;
    loadParticlesOptions?(options: RepulseParticlesOptions, ...sources: (RecursivePartial<IRepulseParticlesOptions> | undefined)[]): void;
    reset(): void;
}
export {};
